///////////////////////////////////////////////////////////////////////////////
//
//  CodeJock.CalendarControl
//
// Notes about CalendarControl:
//
// 1. Events are handled in a different thread in SL2.
//    Can be a problem when using a database opened in main thread.
//
///////////////////////////////////////////////////////////////////////////////


#include "dcdialog.ch"
#INCLUDE "XCodeJock.CH"
#include "Calendar.ch"
#INCLUDE "ActiveX.CH"
#INCLUDE "appevent.CH"

#define ON .t.
#define OFF .f.

#define  DblClick_Event             xbeP_User + 100

FUNCTION Main()

LOCAL GetList[0], GetOptions, oCalendar, oCaptionBar, oDatePicker, oDlg, oImageList, ;
      oMenuBar, oMenuFile, oMenuDebug, oRecord, cLicense, oGlobalSettings

TEXT INTO cLicense WRAP
Calendar Control Copyright (c) 2003-2008 Codejock Software
PRODUCT-ID: Codejock.Calendar.ActiveX.v12.1
VALIDATE-CODE: WAD-FOY-VBC-AED
ENDTEXT

oGlobalSettings := CreateObject('CodeJock.CalendarGlobalSettings' + CJ_Version())
oGlobalSettings:License := cLicense

DC_DotHotKey(xbeK_ALT_F12)

DCMENUBAR oMenuBar OWNERDRAW
DCSUBMENU oMenuFile PROMPT '&Database' PARENT oMenuBar
DCMENUITEM 'Open EVENTS.XML' PARENT oMenuFile ACTION {||SetDataProvider(oCalendar,1,oDlg,@oRecord)}
DCMENUITEM 'Open OutLook Calendar' PARENT oMenuFile ACTION {||SetDataProvider(oCalendar,2,oDlg,@oRecord)}
DCMENUITEM 'Open Calendar.DBF' PARENT oMenuFile ACTION {||SetDataProvider(oCalendar,3,oDlg,@oRecord)}
DCSUBMENU oMenuDebug PROMPT 'De&Bug' PARENT oMenuBar
DCMENUITEM 'Show Properties of Calendar Object' ACTION {||CJ_DisplayProperties(oCalendar)} PARENT oMenuDebug
DCMENUITEM 'Show Properties of Caption Bar Object' ACTION {||CJ_DisplayProperties(oCaptionBar)} PARENT oMenuDebug
DCMENUITEM 'Show Properties of DatePicker Object' ACTION {||CJ_DisplayProperties(oDatePicker)} PARENT oMenuDebug

@ 0,0 DCCJCalendarCaptionBar oCaptionBar SIZE 120,3 ;
      BACKGROUNDCOLOR GRA_CLR_YELLOW ;
      SHOWDATELABEL ON ;
      SHOWEXPANDBUTTON ON ;
      RESIZE DCGUI_RESIZE_REPOSY_RESIZEX

@ 3,100 DCCJDatePicker oDatePicker SIZE 20,20 ;
      AUTOSIZE ON ;
      RESIZE DCGUI_RESIZE_REPOSX_RESIZEY

@ 3,0 DCCJCalendar oCalendar SIZE 100,20 ;
      SHOWCAPTIONBAR OFF ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      EVAL {|o|;
               oCaptionBar:attachToCalendar(o), ;
               oDatePicker:attachToCalendar(o), ;
               SetOptions(o), ;
;//               SetDataProvider(o,3,@oDlg,@oRecord), ;
               o:DblClick := {||PostAppEvent(DblClick_Event,oCalendar,,oDlg)}}

DCUSEREVENT DblClick_Event ACTION {||DoubleClick(oCalendar,@oRecord)}

DCGETOPTIONS ;
   RESIZE ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   TOOLTIPFONT '10.Lucida Console' ;
   HIDE ;
   NOESCAPEKEY ;
   EXITQUERY MSG {||oCalendar:dataProvider:save(),oCalendar:dataProvider:close(),.t.}

DCREAD GUI FIT TITLE 'CodeJock CalendarControl Sample' OPTIONS GetOptions ;
   PARENT @oDlg ;
   ADDBUTTONS ;
   SETAPPWINDOW ;
   EVAL {|o|o:SetPos({o:CurrentPos()[1]-100,o:currentPos()[2]}), ;
            o:show()}

RETURN nil

* ------------

PROC appsys ; RETURN

* ------------

STATIC FUNCTION SetOptions( oCalendar )

LOCAL oOptions := oCalendar:options()

oOptions:FirstDayOfTheWeek := xtpCalendarDayMonday // Monday
oOptions:MonthViewCompressWeekendDays := .F.  // do not compress
oOptions:MonthViewShowTimeAsClocks := .T.   // display start/end time as clock
oOptions:WeekViewShowTimeAsClocks  := .T.   // display start/end time as clock

oOptions:treatDateAsString(.T.):setProperty("WorkDayStartTime",;
               VTType():new( "2008122009:00:00", VT_DATE))

oOptions:treatDateAsString(.T.):setProperty("WorkDayEndTime",;
               VTType():new( "2008122016:00:00", VT_DATE))


DC_GetCargo(oCalendar,Str(Seconds(),5))

RETURN nil

* ------------

STATIC FUNCTION SetDataProvider( oCalendar, nWhich, oDlg, oRecord )

LOCAL cConnectString, i, oItem, oResources, oRes1, oRes2, oSchedules

IF oCalendar:dataProvider:isOpen()
  oCalendar:dataProvider:Save()
  oCalendar:dataProvider:Close()
ENDIF


wtf oCalendar:dataProvider

IF DC_DbSel('CALENDAR')
  CALENDAR->(dbCloseArea())
ENDIF

IF nWhich == 1
  cConnectString := "Provider=XML;Data Source=Events.xml"
ELSEIF nWhich == 2
  cConnectString := "Provider=MAPI;Data Source=C:\Documents and Settings\Roger Donnay\Application Data\Microsoft\Outlook\outcmd.dat"
ELSEIF nWhich == 3
  cConnectString := "Provider=custom;Data Source=Calendar.dbf"
  IF !LoadDbes()
    RETURN .f.
  ENDIF
  USE CALENDAR INDEX CALENDAR
  oRecord := CALENDAR->(DC_DbRecord():new())
  CALENDAR->(dbGoTo(0))
  CALENDAR->(DC_DbScatter(oRecord))
  oCalendar:DoGetAllEventsRaw := {|a,b,c|LoadEventsFromDBF(oCalendar,oRecord)}
ENDIF

oCalendar:SetdataProvider( cConnectString )
IF !oCalendar:dataProvider:Open()
  oCalendar:dataProvider:CallMethod('Create')
ENDIF

oResources := CreateObject('CodeJock.CalendarResources' + CJ_Version())
oRes1 := CreateObject('CodeJock.CalendarResource' + CJ_Version())
oRes2 := CreateObject('CodeJock.CalendarResource' + CJ_Version())

// cConnectString := 'Provider=XML;Data Source=C:\XcodeJock\samples\Calendar\Multiple.xml'

oRes1:SetDataProvider2(cConnectString,.t.)

IF !oRes1:dataProvider:Open()
  IF !oRes1:dataProvider:CallMethod('Create')
    RETURN .f.
  ENDIF
ENDIF
oRes2:SetDataProvider(oRes1:dataProvider,.f.)

oSchedules := oRes1:DataProvider:Schedules
oSchedules:AddNewSchedule('Mary')
oSchedules:AddNewSchedule('John')
oRes1:DataProvider:Save()

oRes1:Name := oSchedules:Item(0):Name
oRes1:ScheduleIDs:Add(oSchedules:Item(0):Id)

oRes2:Name = oSchedules:Item(1):Name
oRes2:ScheduleIDs:Add(oSchedules:Item(1):Id)

oResources:Add(oRes1)
oResources:Add(oRes2)

wtf oResources

// oCalendar:SetMultipleResources(oResources)  // <<< this causes a runtime error

IF nWhich==3
  oCalendar:FireEvent('DoGetAllEventsRaw')
ELSE
  oCalendar:populate()
ENDIF

RETURN oCalendar:dataProvider:IsOpen()

* ------------

STATIC FUNCTION DoubleClick( oCalendar, oRecord )

LOCAL oActiveView, oHitInfo, cName, nNo, cDateTime, dDate, cTime, ;
      oEvent, oViewEvent, nIndex, oCalendarViewEvent

oActiveView := oCalendar:ActiveView

IF oActiveView = NIL
  RETURN .F.
ENDIF

cName := oActiveView:interfaceName

IF EMPTY(cName)
  RETURN .F.
ELSEIF cName == "CalendarDayView"
ELSEIF cName == "CalendarWeekView"
ELSEIF cName == "CalendarMonthView"
ENDIF

oHitInfo := oActiveView:HitTest()
nNo := oHitInfo:hitCode

oHitInfo:treatDateAsString(.t.)
cDateTime := oHitInfo:getProperty('hitDateTime')
CJ_DateTime(cDateTime,@dDate,@cTime)

// Thread():new():start({||cj_displayproperties(oHitInfo)})

oViewEvent := oHitInfo:viewEvent

IF CJ_IsOption(nNo,xtpCalendarHitTestDayHeader) // The position is inside a header
  // not sure what to do here yet

ELSEIF CJ_IsOption(nNo,xtpCalendarHitTestEventTextArea) // The position is inside an existing event
  nIndex := oHitInfo:ViewGroup:ViewEvents:Count
  IF nIndex > 0
    nIndex := oHitInfo:ViewGroup:GroupIndex
    oCalendarViewEvent := oHitInfo:ViewGroup:ViewEvents:ViewEvent(nIndex)
    IF !oCalendarViewEvent == NIL
      oEvent := oCalendarViewEvent:event
    ENDIF
  ENDIF
  EditEvent(oCalendar,oEvent,dDate,cTime,oRecord)

ELSEIF CJ_IsOption(nNo,xtpCalendarHitTestGroupArea)  // The position is inside a group area.
  EditEvent(oCalendar,oEvent,dDate,cTime,oRecord)
ENDIF

RETURN nil

* -------------

STATIC FUNCTION EditEvent( oCalendar, oEvent, dDate, cTime, oRecord )

LOCAL GetList[0], GetOptions, cSubject, cBody, dStart, oLabel, ;
      dEnd, cStart, cEnd, cLocation, aLabels[0], oLabelList, nLabelCount, ;
      i, cLabel, lStatus, oLabelColor, nLabel := 0, lPrivate, lMeeting, ;
      lReminder, nReminderMinutes, nBusyStatus, aBusyStatus, cBusyStatus, ;
      lNew := .f., cDateTime, lAllDayEvent, aScheduleID[0], oItem, ;
      cScheduleID := Space(10), nScheduleID := 0

FOR i := 1 TO oCalendar:dataProvider:Schedules:Count
  oItem := oCalendar:dataProvider:Schedules:Item(i-1)
  AAdd( aScheduleID, { oItem:name, oItem:id } )
NEXT

IF oEvent == nil
  lNew := .t.
  oEvent := oCalendar:dataProvider:createEvent()
ENDIF

wtf oEvent:CustomProperties:Property("EventID")

oLabelList := oCalendar:dataProvider:LabelList()
nLabelCount := oLabelList:count
FOR i := 1 TO nLabelCount
  oLabel := oLabelList:item(i-1)
  AAdd( aLabels, { oLabel:labelId, CJ_Color(oLabel:color,.t.), oLabel:name } )
NEXT

i := AScan( aLabels, {|a|a[1]==oEvent:label} )
cLabel := ''
IF i > 0
  cLabel := Pad(aLabels[i,3],20)
  nLabel := oEvent:label
ENDIF

aBusyStatus := { ;
   { 'Free', xtpCalendarBusyStatusFree }, ;
   { 'Tentative', xtpCalendarBusyStatusTentative }, ;
   { 'Busy', xtpCalendarBusyStatusBusy }, ;
   { 'Out of Office', xtpCalendarBusyStatusOutOfOffice } }

cSubject := Pad(oEvent:subject,50)
cLocation := Pad(oEvent:location,50)
cBody := oEvent:body
cStart := cTime
dStart := dDate
dEnd := dDate
cEnd := CJ_SecsToTs( CJ_TStoSecs(cTime) + 30*60 )

lReminder := oEvent:reminder
nReminderMinutes := oEvent:reminderMinutesBeforeStart
lAllDayEvent := oEvent:allDayEvent
lMeeting := oEvent:meetingFlag
lPrivate := oEvent:privateFlag
nBusyStatus := oEvent:busyStatus
i := AScan(aBusyStatus,{|a|a[2]==nBusyStatus})
IF i == 0
  i := 1
ENDIF
cBusyStatus := Pad(aBusyStatus[i,1],20)

@ 0,0 DCSAY 'Subject' GET cSubject
@ 1,0 DCSAY 'Location' GET cLocation

@ 0,70 DCSAY 'Label' GET cLabel KEYBLOCK {|a,b,o|o:undo()} ;
   POPUP {|c|PopLabel(c,aLabels,oLabelColor,@nLabel)} SAYSIZE 10

@ DCGUI_ROW, DCGUI_COL + 10 DCSAY '' SAYSIZE 3 OBJECT oLabelColor ;
   COLOR nil, GRA_CLR_WHITE

@ 1,70 DCSAY 'Show Time As' GET cBusyStatus SAYSIZE 10 ;
       KEYBLOCK {|a,b,o|o:undo()} ;
       COMBO DATA aBusyStatus HEIGHT 6 WIDTH 20 ;
          RETURN {|n|nBusyStatus := aBusyStatus[n,2],aBusyStatus[n,1]}

@ 3,0 DCSAY 'Start Time' GET dStart POPUP {|d|DC_PopDate(d,,,,,,2)}
@ DCGUI_ROW, DCGUI_COL + 10 DCGET cStart PICTURE '99:99:99' POPUP {|c|PopTime(c,30)} HIDE {||lAllDayEvent}

@ 4,0 DCSAY 'End Time' GET dEnd POPUP {|d|DC_PopDate(d,,,,,,2)}
@ DCGUI_ROW, DCGUI_COL + 10 DCGET cEnd PICTURE '99:99:99' POPUP {|c|PopTime(c,30)} HIDE {||lAllDayEvent}

@ 3,45 DCCHECKBOX lAllDayEvent PROMPT 'All Day Event'

@ 3,70 DCCHECKBOX lPrivate PROMPT 'Private'
@ 4,70 DCCHECKBOX lMeeting PROMPT 'Meeting'

@ 6,0 DCCHECKBOX lReminder PROMPT 'Reminder'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Minutes' GET nReminderMinutes PICT '9999' ;
   WHEN {||lReminder}

@ 6,35 DCSAY 'Schedule ID' GET cScheduleID ;
       KEYBLOCK {|a,b,o|o:undo()} ;
       COMBO DATA aScheduleID HEIGHT 6 WIDTH 15 ;
          RETURN {|n|nScheduleID := aScheduleID[n,2],aScheduleID[n,1]}

@ 8,0 DCMULTILINE cBody SIZE 100, 10 NOHSCROLL FONT '10.Lucida Console'

@ 8,102 DCPUSHBUTTON CAPTION 'Properties' SIZE 9,1.2 ACTION {||CJ_DisplayProperties(oEvent)}

DCGETOPTIONS SAYWIDTH 60 SAYRIGHTBOTTOM TABSTOP

DCREAD GUI FIT ADDBUTTONS TITLE IIF(lNew,'Adding','Editing') + ' event' ;
   MODAL SETAPPWINDOW TO lStatus OPTIONS GetOptions

IF lStatus

  oEvent:subject := Trim(cSubject)
  oEvent:body := cBody
  oEvent:location := Trim(cLocation)
  oEvent:privateFlag := lPrivate
  oEvent:meetingFlag := lMeeting
  oEvent:busyStatus := nBusyStatus
  oEvent:label := nLabel
  oEvent:reminder := lReminder
  oEvent:scheduleID := nScheduleID
  oEvent:allDayEvent := lAllDayEvent
  oEvent:reminderMinutesBeforeStart := nReminderMinutes
  oEvent:treatDateAsString(.t.)
  CJ_DateTime(@cDateTime,dStart,cStart)
  oEvent:startTime := cDateTime
  CJ_DateTime(@cDateTime,dEnd,cEnd)
  oEvent:endTime := cDateTime
  IF lNew
    oCalendar:dataProvider:addEvent(oEvent)
  ELSE
    oCalendar:dataProvider:changeEvent(oEvent)
  ENDIF

  oCalendar:populate()

  IF !lNew
    // put something here to find event in database
  ENDIF
  oRecord:subject := cSubject
  oRecord:body := cBody
  oRecord:location := Trim(cLocation)
  oRecord:startDate := dStart
  oRecord:endDate := dEnd
  oRecord:startTime := cStart
  oRecord:endTime := cEnd
  oRecord:isPrivate := lPrivate
  oRecord:isMeeting := lMeeting
  oRecord:isReminder := lReminder
  oRecord:remindTime := nReminderMinutes
  oRecord:busyStatus := nBusyStatus
  oRecord:eventID := oEvent:id
  oRecord:isAllDay := lAllDayEvent
  oRecord:user_id := cScheduleID
  CALENDAR->(DC_DbGather(oRecord,lNew))
ENDIF

RETURN nil

* ------------

STATIC FUNCTION LoadEventsFromDBF( oCalendar, oRecord )

LOCAL oEvent, cDateTime, i, oItem, nScheduleID, aScheduleID[0]

FOR i := 1 TO oCalendar:dataProvider:Schedules:Count
  oItem := oCalendar:dataProvider:Schedules:Item(i-1)
  AAdd( aScheduleID, { oItem:name, oItem:id } )
NEXT

CALENDAR->(dbGoTop())
DO WHILE !CALENDAR->(Eof())
  CALENDAR->(DC_DbScatter(oRecord))
  nScheduleID := AScan(aScheduleID,{|a|Upper(a[1])==Upper(Trim(oRecord:user_id))})
  IF nScheduleID > 0
    nScheduleID := aScheduleID[nScheduleID,2]
  ENDIF
  oEvent := oCalendar:dataProvider:createEvent()
  oEvent:CustomProperties:setProperty('Property','EventID', oRecord:eventID )
  oEvent:scheduleID := nScheduleID
  oEvent:subject := Trim(oRecord:subject)
  oEvent:body := oRecord:body
  oEvent:location := Trim(oRecord:location)
  oEvent:privateFlag := oRecord:isPrivate
  oEvent:meetingFlag := oRecord:isMeeting
  oEvent:busyStatus := oRecord:busyStatus
  oEvent:label := oRecord:label
  oEvent:reminder := oRecord:isReminder
  oEvent:reminderMinutesBeforeStart := oRecord:remindTime
  oEvent:allDayEvent := oRecord:isAllDay
  oEvent:treatDateAsString(.t.)
  CJ_DateTime(@cDateTime,oRecord:startDate,oRecord:startTime)
  oEvent:startTime := cDateTime
  CJ_DateTime(@cDateTime,oRecord:endDate,oRecord:endTime)
  oEvent:endTime := cDateTime
  oCalendar:dataProvider:addEvent(oEvent)
  CALENDAR->(dbSkip())
ENDDO
oCalendar:populate()

RETURN nil

* ------------

STATIC FUNCTION PopLabel( cName, aLabels, oLabelColor, nLabel )

LOCAL GetList[0], GetOptions, oBrowse, nPointer := 1, lStatus

@ 0,0 DCBROWSE oBrowse DATA aLabels SIZE 30,16 FIT  ;
      POINTER nPointer ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      COLOR {||{nil,aLabels[oBrowse:arrayElement,2]}}

DCBROWSECOL ELEMENT 3 HEADER 'Label Name' PARENT oBrowse WIDTH 20 ;

DCREAD GUI FIT ADDBUTTONS MODAL SETAPPWINDOW ;
   TITLE 'Choose a Label' TO lStatus

IF lStatus
  oLabelColor:setColorBG(aLabels[nPointer,2])
  cName := aLabels[nPointer,3]
  nLabel := aLabels[nPointer,1]
ENDIF

RETURN cName

* ------------

STATIC FUNCTION PopTime( cTime, nMinutes )

LOCAL GetList[0], GetOptions, i, oBrowse, aTime[0], nPointer := 1, ;
      cTimeSecs, lStatus, nSecs, nStartSecs

nStartSecs := CJ_TsToSecs(cTime)
nSecs := 0
FOR i := 1 TO 48
  nSecs += (30*60)
  cTimeSecs := CJ_SecsToTs(nSecs)
  IF cTimeSecs == cTime
    nPointer := i
  ENDIF
  cTimeSecs += ' (' + Substr(CJ_SecsToTs(nSecs-nStartSecs),1,5) + ' Hours/Minutes)'
  AAdd( aTime, { i, cTimeSecs } )
NEXT

@ 0,0 DCBROWSE oBrowse DATA aTime SIZE 20,20 FIT ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      POINTER nPointer ;
      FONT '10.Lucida Console'

DCBROWSECOL ELEMENT 2 PARENT oBrowse WIDTH 35

DCGETOPTIONS NORESIZE

DCREAD GUI FIT ADDBUTTONS MODAL TITLE 'Choose a Time' ;
   OPTIONS GetOptions TO lStatus

IF lStatus
  cTime := Substr(aTime[nPointer,2],1,8)
ENDIF

RETURN cTime

* -----------

STATIC FUNCTION LoadDbes()

LOCAL i, aDbeList := DbeList(), cDbeList := '', lStatus := .f.

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

BEGIN SEQUENCE

IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
  DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  BREAK
ENDIF

IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
  DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  BREAK
ENDIF

IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
  DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  BREAK
ENDIF

DbeSetDefault('FOXCDX')

lStatus := .t.

END SEQUENCE

RETURN lStatus

