///////////////////////////////////////////////////////////////////////////////
//
//  CodeJock.CalendarControl
//
// Notes about CalendarControl:
//
// 1. Events are handled in a different thread in SL2.
//    Can be a problem when using a database opened in main thread.
///////////////////////////////////////////////////////////////////////////////


#include "dcdialog.ch"
#INCLUDE "XCodeJock.CH"
#include "Calendar.ch"
#INCLUDE "ActiveX.CH"
#INCLUDE "appevent.CH"

#define ON .t.
#define OFF .f.

#define  DblClick_Event             xbeP_User + 100
#define  nTimerLoop                 10				// seconds for the timer.

FUNCTION Main()
***************
LOCAL GetList[0], GetOptions, oCalendar, oCaptionBar, oDatePicker, oDlg, oImageList, ;
      oMenuBar, oMenuFile, oMenuDebug, oRecord, nVisualTheme, oGroup, bAction

CJ_Version('13.0.0')

nVisualTheme := xtpCalendarThemeOffice2007

DC_DotHotKey(xbeK_ALT_F12)

DCMENUBAR oMenuBar OWNERDRAW
DCSUBMENU oMenuDebug PROMPT 'De&Bug' PARENT oMenuBar
DCMENUITEM 'Show Properties of Calendar Object' ACTION {||CJ_DisplayProperties(oCalendar)} PARENT oMenuDebug
DCMENUITEM 'Show Properties of Caption Bar Object' ACTION {||CJ_DisplayProperties(oCaptionBar)} PARENT oMenuDebug
DCMENUITEM 'Show Properties of DatePicker Object' ACTION {||CJ_DisplayProperties(oDatePicker)} PARENT oMenuDebug

@ 0,0 CJCalendarCaptionBar oCaptionBar SIZE 120,3 ;
      BACKGROUNDCOLOR GRA_CLR_YELLOW ;
      SHOWDATELABEL ;
      SHOWSWITCHVIEWBUTTONS ;
      SHOWEXPANDBUTTON ;
      RESIZE DCGUI_RESIZE_REPOSY_RESIZEX

@ 3,100 CJDatePicker oDatePicker SIZE 20,20 ;
      AUTOSIZE ;
      RESIZE DCGUI_RESIZE_REPOSX_RESIZEY

@ 3,0 CJCalendar oCalendar SIZE 100,20 ;
      VISUALTHEME nVisualTheme ;
      SHOWCAPTIONBAR ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      EVAL {|o|oCaptionBar:attachToCalendar(o), ;
               oDatePicker:attachToCalendar(o), ;
               SetOptions(o), ;
               SetDataProvider(o,3,@oDlg,@oRecord) , ;
               o:DblClick := {||PostAppEvent(DblClick_Event,oCalendar,,oDlg)}}

bAction := {||oCalendar:visualTheme := nVisualTheme}

@ 0,121 DCGROUP oGroup CAPTION 'Visual Theme' SIZE 18,6 RESIZE DCGUI_RESIZE_REPOSONLY
@ 1,2 DCRADIO nVisualTheme VALUE xtpCalendarThemeOffice2000 ACTION bAction PARENT oGroup PROMPT 'Office 2000'
@ 2,2 DCRADIO nVisualTheme VALUE xtpCalendarThemeOfficeXP ACTION bAction PARENT oGroup PROMPT 'Office XP'
@ 3,2 DCRADIO nVisualTheme VALUE xtpCalendarThemeOffice2003 ACTION bAction PARENT oGroup PROMPT 'Office 2003'
@ 4,2 DCRADIO nVisualTheme VALUE xtpCalendarThemeOffice2007 ACTION bAction PARENT oGroup PROMPT 'Office 2007'

DCUSEREVENT DblClick_Event ACTION {||DoubleClick(oCalendar,@oRecord)}

DCGETOPTIONS ;
   RESIZE ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   TOOLTIPFONT '10.Lucida Console' ;
   NOESCAPEKEY ;
   EXITQUERY MSG {||oDatePicker:detachfromcalendar(),;
   				     oCaptionBar:detachfromcalendar(),;
   						oCalendar:dataProvider:save(),oCalendar:dataProvider:close(),.t.}

DCREAD GUI FIT TITLE 'CodeJock CalendarControl Sample' OPTIONS GetOptions ;
   PARENT @oDlg ;
   ADDBUTTONS ;
   SETAPPWINDOW ;

  	QUIT

RETURN nil

* ------------

PROC appsys ; RETURN

* ------------

STATIC FUNCTION SetOptions( oCalendar,oCaptionBar )
***************************************************
LOCAL oOptions := oCalendar:options()
// Local cXml := '<Calendar CompactMode="1"><CustomProperties><CustomProperty Name="eventid"/><CustomProperty Name="type"/><CustomProperty Name="volgnr"/></CustomProperties></Calendar>'

Local oDayView := oCalendar:DayView() , cText := ""
Local oProperties

// oCalendar:CustomProperties:loadfromstring(cXml)

oCalendar:ShowTimelineButton := .F.

oOptions:MonthViewShowTimeAsClocks := .T.   // display start/end time as clock
oOptions:WeekViewShowTimeAsClocks  := .T.   // display start/end time as clock
oCalendar:UseMultiColumnWeekMode := .T.            // this must be set BEFORE the viewtype!
oCalendar:viewtype := xtpCalendarFullWeekView

oOptions:TooltipAddNewText := "Klik om event toe te voegen."

oOptions:FirstDayOfTheWeek := xtpCalendarDayMonday // Monday
oOptions:MonthViewCompressWeekendDays := .F.  // do not compress

// chris 28/02
oOptions:treatDateAsString(.T.)
oOptions:WorkDayStartTime := "18991230090000"
oOptions:WorkDayEndTime := "18991230190000"
oDayView:ScrollToWorkDayBegin()

DC_GetCargo(oCalendar,str(seconds(),5))

RETURN nil

* ------------

STATIC FUNCTION SetDataProvider( oCalendar, nWhich, oDlg, oRecord )
*******************************************************************
LOCAL cConnectString, i, oItem, oResources, oRes1, oRes2, oSchedules

IF oCalendar:dataProvider:isOpen()
  oCalendar:dataProvider:Save()
  oCalendar:dataProvider:Close()
ENDIF

IF DC_DbSel('CALENDAR')
  CALENDAR->(dbCloseArea())
ENDIF

  cConnectString := "Provider=custom;Data Source=Calendar.dbf"
  IF !LoadDbes()
    RETURN .f.
  ENDIF
  USE CALENDAR alias calendar new
  set index to calend1, calend2, calend3
  oRecord := CALENDAR->(DC_DbRecord():new())
  CALENDAR->(dbGoTo(0))
  CALENDAR->(DC_DbScatter(oRecord))

  oCalendar:DoGetAllEventsRaw := {|a,b,c|LoadEventsFromDBF(oCalendar,oRecord)}   // disabled on 0903
  // chris 28/02  adding the DOxxxEvents
  oCalendar:DoupdateEvent := {|o| cjUpdateEvent(o) }
  oCalendar:DoCreateEvent := {|o| cjCreateEvent(o) }
  oCalendar:DoDeleteEvent := {|o| cjDeleteEvent(o) }
  //  oCalendar:DoReadEvent :=   {|o| msgbox("readevent") }
  fCalendarCargo(oCalendar:cargo)     // this identifies the calendar. We need to know is an event is added or modified on local station.

oCalendar:SetdataProvider( cConnectString )
IF !oCalendar:dataProvider:Open()
  oCalendar:dataProvider:CallMethod('Create')
ENDIF

/* chris 28/02 disable this at this moment for testing ************
oResources := CreateObject('CodeJock.CalendarResources' + CJ_Version())
oRes1 := CreateObject('CodeJock.CalendarResource' + CJ_Version())
oRes2 := CreateObject('CodeJock.CalendarResource' + CJ_Version())

// cConnectString := 'Provider=XML;Data Source=C:\XcodeJock\samples\Calendar\Multiple.xml'

oRes1:SetDataProvider2(cConnectString,.t.)

IF !oRes1:dataProvider:Open()
  IF !oRes1:dataProvider:CallMethod('Create')
    RETURN .f.
  ENDIF
ENDIF
oRes2:SetDataProvider(oRes1:dataProvider,.f.)

oSchedules := oRes1:DataProvider:Schedules
oSchedules:AddNewSchedule('Mary')
oSchedules:AddNewSchedule('John')
oRes1:DataProvider:Save()

oRes1:Name := oSchedules:Item(0):Name
oRes1:ScheduleIDs:Add(oSchedules:Item(0):Id)

oRes2:Name = oSchedules:Item(1):Name
oRes2:ScheduleIDs:Add(oSchedules:Item(1):Id)

oResources:Add(oRes1)
oResources:Add(oRes2)

// oCalendar:SetMultipleResources(oResources)  // <<< this causes a runtime error
// chris 28/02 end disable
*/

oCalendar:FireEvent('DoGetAllEventsRaw')

RETURN oCalendar:dataProvider:IsOpen()

* -------------
static function cjUpdateEvent(oEvent)
*************************************
Local nEventID := oEvent:CustomProperties:property("eventid") , dStart , cStart , dEnd , cEnd , cstarttime , cEndtime

if !fGetSetUpdateEvent()  // this event is modified by someone else. It was saved on his changement, we don't need to save it now.
// wtf 'event niet verwerken'
    fGetSetUpdateEvent(.T.)
    return nil
endif
// wtf 'save that event'
oEvent:treatDateAsString(.t.)
cStarttime := oEvent:starttime
cEndTime := oEvent:endtime
calendar->(dbseek(nEventId))
if !calendar->(eof())
  dStart := stod( left(cStartTime,8) )
  cStart := substr(cStartTime,9,2)+":"+substr(cStartTime,11,2)+":"+substr(cStartTime,13,2)
  dEnd := stod( left(cEndTime,8) )
  cEnd := substr(cEndTime,9,2)+":"+substr(cEndTime,11,2)+":"+substr(cEndTime,13,2)

  calendar->(dbrlock())
  calendar->startdate := dStart
  calendar->starttime := cStart
  calendar->enddate := dEnd
  calendar->endtime := cEnd
  calendar->subject	:= oEvent:subject
  calendar->body 	:= oEvent:body
  calendar->location 	:= oEvent:location
  calendar->isprivate	:= oEvent:privateFlag
  calendar->ismeeting   := oEvent:meetingFlag
  calendar->busystatus  := oEvent:busyStatus
  calendar->label       := oEvent:label
  calendar->isreminder  := oEvent:reminder
  calendar->remindtime  := oEvent:reminderMinutesBeforeStart
  calendar->isAllday    := oEvent:allDayEvent
  calendar->timekey     := dtos(date())+padl(str(seconds(),5),5,"0")
  calendar->calid       := fCalendarCargo()
  calendar->(dbrunlock())
  calendar->(dbcommit())
endif
return nil

* ------------
// chris 01/03
static function cjCreateEvent(oEvent)
*************************************
Local nEventID , nCount := oEvent:CustomProperties:count()
Local  dStart , cStart , dEnd , cEnd, cstarttime , cEndtime

if !nCount > 0 // Nieuw event, er zijn nog geen extra properties aanwezig. Events uit de database hebben wel extra properties.
  calendar->(dbappend())
  oEvent:treatDateAsString(.t.)
  cStarttime := oEvent:starttime
  cEndTime := oEvent:endtime
  dStart := stod( left(cStartTime,8) )
  cStart := substr(cStartTime,9,2)+":"+substr(cStartTime,11,2)+":"+substr(cStartTime,13,2)
  dEnd := stod( left(cEndTime,8) )
  cEnd := substr(cEndTime,9,2)+":"+substr(cEndTime,11,2)+":"+substr(cEndTime,13,2)
  calendar->eventid 	:= seconds()                     // is not a unique key, can create duplicates, will do for testing.
  oEvent:CustomProperties:setproperty("property","eventid",calendar->eventid)
  fListWithActiveEvents(oEvent:ID,Calendar->eventID)               // add the new event to the array
  calendar->startdate 	:= dStart
  calendar->starttime 	:= cStart
  calendar->enddate 	:= dEnd
  calendar->endtime 	:= cEnd
  calendar->subject	:= oEvent:subject

  calendar->body 	:= oEvent:body
  calendar->location 	:= oEvent:location
  calendar->isprivate	:= oEvent:privateFlag
  calendar->ismeeting   := oEvent:meetingFlag
  calendar->busystatus  := oEvent:busyStatus
  calendar->label       := oEvent:label
  calendar->isreminder  := oEvent:reminder
  calendar->remindtime  := oEvent:reminderMinutesBeforeStart
  calendar->isAllday    := oEvent:allDayEvent
  calendar->timekey     := dtos(date())+padl(str(seconds(),5),5,"0")
  calendar->calid       := fCalendarCargo()
  calendar->(dbrunlock())

endif
return nil

static function cjDeleteEvent(oEvent)
***************************************
Local nEventID := oEvent:CustomProperties:property("eventid") , dStart , cStart , dEnd , cEnd , cstarttime , cEndtime
Local nDeleteEvent := oEvent:id

calendar->(dbseek(nEventId))
if !calendar->(eof()) .and. !calendar->delevent
    calendar->(rlock())
    calendar->timekey := dtos(date())+padl(str(seconds(),5),5,"0")
    calendar->calid   := fCalendarCargo()
    calendar->delevent := .T.
    calendar->(dbrunlock())
endif
fListWithActiveEvents(nDeleteEvent,0)    // delete it in our array with active events
return nil


STATIC FUNCTION LoadEventsFromDBF( oCalendar, oRecord )
*******************************************************
LOCAL oEvent, cDateTime, i, oItem, nScheduleID, aScheduleID[0] , oProperties

FOR i := 1 TO oCalendar:dataProvider:Schedules:Count
  oItem := oCalendar:dataProvider:Schedules:Item(i-1)
  AAdd( aScheduleID, { oItem:name, oItem:id } )
NEXT

CALENDAR->(dbGoTop())
DO WHILE !CALENDAR->(Eof())
 if !calendar->delevent
  CALENDAR->(DC_DbScatter(oRecord))    // using oRecord
  nScheduleID := AScan(aScheduleID,{|a|Upper(a[1])==Upper(Trim(oRecord:user_id))})
  IF nScheduleID > 0
    nScheduleID := aScheduleID[nScheduleID,2]
  ENDIF
  oEvent := oCalendar:DataProvider:createEvent()   // CreateEventEx( CALENDAR->EVENTID )   Not needed anymore. :-)
  oEvent:scheduleID := nScheduleID
  oEvent:subject := Trim(oRecord:subject)
  oEvent:body := oRecord:body
  oEvent:location := Trim(oRecord:location)
  oEvent:privateFlag := oRecord:isPrivate
  oEvent:meetingFlag := oRecord:isMeeting
  oEvent:busyStatus := oRecord:busyStatus
  oEvent:label := oRecord:label
  oEvent:reminder := oRecord:isReminder
  oEvent:reminderMinutesBeforeStart := oRecord:remindTime
  oEvent:allDayEvent := oRecord:isAllDay
  oEvent:treatDateAsString(.t.)
  CJ_DateTime(@cDateTime,oRecord:startDate,oRecord:startTime)
  oEvent:startTime := cDateTime
  CJ_DateTime(@cDateTime,oRecord:endDate,oRecord:endTime)
  oEvent:endTime := cDateTime
  oEvent:CustomProperties:setProperty('Property','EventID', calendar->eventid )   // This is our unique ID.
  fListWithActiveEvents(oEvent:ID,Calendar->eventID)    // build the array with the events we loaded.
  oCalendar:dataProvider:addEvent(oEvent)
 endif
 CALENDAR->(dbSkip())
ENDDO
oCalendar:populate()

RETURN nil

STATIC function fCheckNewEvents(oCalendar)
******************************************
Local nEventID , lDeleted , nCalendarID
Local cTimeKey := dtos(date())+padl(str(seconds()-nTimerLoop*2+1,5),5,"0")     // timer is nTimerLoop seconds, some seconds extra to be sure we have everything
Local oRecord , oEvent ,cDateTime
static lBusy
default lBusy := .F.

if !lBusy                  // in case this takes longer than expected and the timer knocks on the door again. :)
    lBusy := .T.
    USE CALENDAR alias calendarcheck new
    set index to calend3
    oRecord := CALENDARcheck->(DC_DbRecord():new())
    calendarcheck->(dbgobottom())
    do while calendarcheck->timekey > cTimeKey
      if calendarcheck->calid # fCalendarCargo()   // someone else created or modified it.
        nEventID := fListWithActiveEvents(0,calendarcheck->eventid)        // Search if this is a known event

        if !calendarcheck->delevent     // this is a new OR changed event. Add OR modify this to the calendar
		  CALENDARcheck->(DC_DbScatter(oRecord))    // using oRecord
		  //nScheduleID := AScan(aScheduleID,{|a|Upper(a[1])==Upper(Trim(oRecord:user_id))})
		  //IF nScheduleID > 0
		  //  nScheduleID := aScheduleID[nScheduleID,2]
		  // ENDIF
                  if nEventID = 0
		      oEvent := oCalendar:DataProvider:createEvent()   // create the event
                    else
                      oEvent := oCalendar:dataProvider:getEvent(nEventID)   // get the event
                  endif
		  oEvent:scheduleID := 1 // nScheduleID
		  oEvent:subject := Trim(oRecord:subject)
		  oEvent:body := oRecord:body
		  oEvent:location := Trim(oRecord:location)
		  oEvent:privateFlag := oRecord:isPrivate
		  oEvent:meetingFlag := oRecord:isMeeting
		  oEvent:busyStatus := oRecord:busyStatus
		  oEvent:label := oRecord:label
		  oEvent:reminder := oRecord:isReminder
		  oEvent:reminderMinutesBeforeStart := oRecord:remindTime
		  oEvent:allDayEvent := oRecord:isAllDay
		  oEvent:treatDateAsString(.t.)
		  CJ_DateTime(@cDateTime,oRecord:startDate,oRecord:startTime)
		  oEvent:startTime := cDateTime
		  CJ_DateTime(@cDateTime,oRecord:endDate,oRecord:endTime)
		  oEvent:endTime := cDateTime
                  if nEventID = 0
 		      oEvent:CustomProperties:setProperty('Property','EventID', calendarcheck->eventid )   // This is our unique ID.
		      fListWithActiveEvents(oEvent:ID,Calendarcheck->eventID)    // build the array with the events we loaded.
 		      oCalendar:dataProvider:addEvent(oEvent)
                    else
                      fGetSetUpdateEvent(.F.)   // doUpdateEvent must be suppressed.
 		      oCalendar:dataProvider:ChangeEvent(oEvent)
                  endif
        endif
        if abs(nEventID) > 0 .and. calendarcheck->delevent   // this is a event that was deleted by someone else.
                  oEvent := oCalendar:dataProvider:getEvent(nEventID)
                  oCalendar:dataProvider:deleteEvent( oEvent)
        endif

      endif
      calendarcheck->(dbskip(-1))
    enddo
    calendarcheck->(dbclosearea())
    lBusy := .F.

    fGetSetUpdateEvent(.T.)   // doUpdateEvent becomes active again
endif
return nil


STATIC function fListWithActiveEvents(nEventID,nCalendarID)
***********************************************************
Local nPos

static aEventkeys , aCalendarKeys

default aEventKeys := {} , aCalendarKeys := {}

if nCalendarID > 0 .and. nEventID == 0    // search if the event already exist, if so return the oEvent:ID
                                          // this way we can find the ID
    nPos := ascan(aCalendarKeys,nCalendarID)
    if nPos > 0
        return aEventKeys[nPos]
    endif
  elseif nCalendarID > 0 .and. abs(nEventID) > 0  // add this event to the array
    aadd(aCalendarkeys,nCalendarID)
    aadd(aEventkeys,nEventID)
  elseif nCalendarID == 0 .and. abs(nEventID) > 0
    nPos := ascan(aEventKeys,nEventID)
    if nPos > 0
        aDel(aEventKeys,nPos)
        aDel(aCalendarKeys,nPos)
        nPos := len(aEventKeys)
        ASize( aEventKeys, nPos )
        ASize( aCalendarKeys, nPos )
    endif

endif

// search if all the calendar events are still in the database, if not, delete them.


return 0

Static function fCalendarCargo(Cargo)
**********************************

Static Calid := ''

default calid :=cargo

return calid



static function fGetSetUpdateEvent(lUpdate)
********************************************

static lUpdateFlag
default lUpdateFlag := .T.

if valtype(lUpdate) == "L"
    lUpdateFlag := lUpdate
endif
// wtf lUpdate,lUpdateFlag
return lUpdateFlag


STATIC FUNCTION PopLabel( cName, aLabels, oLabelColor, nLabel )
***************************************************************
LOCAL GetList[0], GetOptions, oBrowse, nPointer := 1, lStatus

@ 0,0 DCBROWSE oBrowse DATA aLabels SIZE 30,16 FIT  ;
      POINTER nPointer ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      COLOR {||{nil,aLabels[oBrowse:arrayElement,2]}}

DCBROWSECOL ELEMENT 3 HEADER 'Label Name' PARENT oBrowse WIDTH 20 ;

DCREAD GUI FIT ADDBUTTONS MODAL SETAPPWINDOW ;
   TITLE 'Choose a Label' TO lStatus

IF lStatus
  oLabelColor:setColorBG(aLabels[nPointer,2])
  cName := aLabels[nPointer,3]
  nLabel := aLabels[nPointer,1]
ENDIF

RETURN cName

* ------------

STATIC FUNCTION PopTime( cTime, nMinutes )
*******************************************
LOCAL GetList[0], GetOptions, i, oBrowse, aTime[0], nPointer := 1, ;
      cTimeSecs, lStatus, nSecs, nStartSecs

nStartSecs := CJ_TsToSecs(cTime)
nSecs := 0
FOR i := 1 TO 48
  nSecs += (30*60)
  cTimeSecs := CJ_SecsToTs(nSecs)
  IF cTimeSecs == cTime
    nPointer := i
  ENDIF
  cTimeSecs += ' (' + Substr(CJ_SecsToTs(nSecs-nStartSecs),1,5) + ' Hours/Minutes)'
  AAdd( aTime, { i, cTimeSecs } )
NEXT

@ 0,0 DCBROWSE oBrowse DATA aTime SIZE 20,20 FIT ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      POINTER nPointer ;
      FONT '10.Lucida Console'

DCBROWSECOL ELEMENT 2 PARENT oBrowse WIDTH 35

DCGETOPTIONS NORESIZE

DCREAD GUI FIT ADDBUTTONS MODAL TITLE 'Choose a Time' ;
   OPTIONS GetOptions TO lStatus

IF lStatus
  cTime := Substr(aTime[nPointer,2],1,8)
ENDIF

RETURN cTime


STATIC FUNCTION LoadDbes()
****************************
LOCAL i, aDbeList := DbeList(), cDbeList := '', lStatus := .f.

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

BEGIN SEQUENCE

IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
  DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  BREAK
ENDIF

IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
  DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  BREAK
ENDIF

IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
  DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  BREAK
ENDIF

DbeSetDefault('DBFNTX')

lStatus := .t.

END SEQUENCE

RETURN lStatus

* ------------


***************************************************
// code below this line isn't used at this moment.
////////////////////////////////////////////////////////////////////////

/*   Not needed at this time.
cXml := '<Calendar CompactMode="1"><CustomProperties><CustomProperty Name="eventid"/><CustomProperty Name="type"/><CustomProperty Name="volgnr"/></CustomProperties></Calendar>'
oEvent:CustomProperties:loadfromstring(cXml)
cText := oEvent:CustomProperties:savetostring()
wtf cText
nProperties := oEvent:CustomProperties:count()
wtf nProperties
*/

/* ------------
STATIC FUNCTION TimerHandler( nEvent, mp1, mp2, oXbp, oDlg, aGetlist, aRef, lOk , oCalendar )

Local nWaitSeconds := 15 , nSeconds := seconds()
Static nPrevious
default nPrevious := nSeconds

if nPrevious+nWaitseconds < nSeconds .or. nPrevious > nSeconds
wtf valtype(oCalendar)
    if valtype(oCalendar) == "O"
        fCheckNewEvents(@oCalendar)
        oCalendar:populate()
    endif
    nPrevious := nSeconds
endif

RETURN DCGUI_NONE
*/


STATIC FUNCTION EditEvent( oCalendar, oEvent, dDate, cTime, oRecord )
*********************************************************************
LOCAL GetList[0], GetOptions, cSubject, cBody, dStart, oLabel, ;
      dEnd, cStart, cEnd, cLocation, aLabels[0], oLabelList, nLabelCount, ;
      i, cLabel, lStatus, oLabelColor, nLabel := 0, lPrivate, lMeeting, ;
      lReminder, nReminderMinutes, nBusyStatus, aBusyStatus, cBusyStatus, ;
      lNew := .f., cDateTime, lAllDayEvent, aScheduleID[0], oItem, ;
      cScheduleID := Space(10), nScheduleID := 0 , nEventID := 0

FOR i := 1 TO oCalendar:dataProvider:Schedules:Count
  oItem := oCalendar:dataProvider:Schedules:Item(i-1)
  AAdd( aScheduleID, { oItem:name, oItem:id } )
NEXT

// start chris 28/02   - If an existing event read the start and end time
IF oEvent == nil
  lNew := .t.
  dStart := dDate
  cStart := cTime
  oEvent := oCalendar:dataProvider:createEvent()
  dEnd := dDate
  cEnd := CJ_SecsToTs( CJ_TStoSecs(cTime) + 30*60 )
 else
  CJ_DateTime(oEvent:starttime,@dStart,@cStart)
  CJ_DateTime(oEvent:endtime,@dEnd,@cEnd)
ENDIF
// end chris 28/02

oLabelList := oCalendar:dataProvider:LabelList()
nLabelCount := oLabelList:count
FOR i := 1 TO nLabelCount
  oLabel := oLabelList:item(i-1)
  AAdd( aLabels, { oLabel:labelId, CJ_Color(oLabel:color,.t.), oLabel:name } )
NEXT

i := AScan( aLabels, {|a|a[1]==oEvent:label} )
cLabel := ''
IF i > 0
  cLabel := Pad(aLabels[i,3],20)
  nLabel := oEvent:label
ENDIF

aBusyStatus := { ;
   { 'Free', xtpCalendarBusyStatusFree }, ;
   { 'Tentative', xtpCalendarBusyStatusTentative }, ;
   { 'Busy', xtpCalendarBusyStatusBusy }, ;
   { 'Out of Office', xtpCalendarBusyStatusOutOfOffice } }

cSubject := Pad(oEvent:subject,50)
cLocation := Pad(oEvent:location,50)
cBody := oEvent:body

lReminder := oEvent:reminder
nReminderMinutes := oEvent:reminderMinutesBeforeStart
lAllDayEvent := oEvent:allDayEvent
lMeeting := oEvent:meetingFlag
lPrivate := oEvent:privateFlag
nBusyStatus := oEvent:busyStatus
i := AScan(aBusyStatus,{|a|a[2]==nBusyStatus})
IF i == 0
  i := 1
ENDIF
cBusyStatus := Pad(aBusyStatus[i,1],20)

@ 0,0 DCSAY 'Subject' GET cSubject
@ 1,0 DCSAY 'Location' GET cLocation

@ 0,70 DCSAY 'Label' GET cLabel KEYBLOCK {|a,b,o|o:undo()} ;
   POPUP {|c|PopLabel(c,aLabels,oLabelColor,@nLabel)} SAYSIZE 10

@ DCGUI_ROW, DCGUI_COL + 10 DCSAY '' SAYSIZE 3 OBJECT oLabelColor ;
   COLOR nil, GRA_CLR_WHITE

@ 1,70 DCSAY 'Show Time As' GET cBusyStatus SAYSIZE 10 ;
       KEYBLOCK {|a,b,o|o:undo()} ;
       COMBO DATA aBusyStatus HEIGHT 6 WIDTH 20 ;
          RETURN {|n|nBusyStatus := aBusyStatus[n,2],aBusyStatus[n,1]}

@ 3,0 DCSAY 'Start Time' GET dStart POPUP {|d|DC_PopDate(d,,,,,,2)}
@ DCGUI_ROW, DCGUI_COL + 10 DCGET cStart PICTURE '99:99:99' POPUP {|c|PopTime(c,30)} HIDE {||lAllDayEvent}

@ 4,0 DCSAY 'End Time' GET dEnd POPUP {|d|DC_PopDate(d,,,,,,2)}
@ DCGUI_ROW, DCGUI_COL + 10 DCGET cEnd PICTURE '99:99:99' POPUP {|c|PopTime(c,30)} HIDE {||lAllDayEvent}

@ 3,45 DCCHECKBOX lAllDayEvent PROMPT 'All Day Event'

@ 3,70 DCCHECKBOX lPrivate PROMPT 'Private'
@ 4,70 DCCHECKBOX lMeeting PROMPT 'Meeting'

@ 6,0 DCCHECKBOX lReminder PROMPT 'Reminder'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Minutes' GET nReminderMinutes PICT '9999' ;
   WHEN {||lReminder}

@ 6,35 DCSAY 'Schedule ID' GET cScheduleID ;
       KEYBLOCK {|a,b,o|o:undo()} ;
       COMBO DATA aScheduleID HEIGHT 6 WIDTH 15 ;
          RETURN {|n|nScheduleID := aScheduleID[n,2],aScheduleID[n,1]}

@ 8,0 DCMULTILINE cBody SIZE 100, 10 NOHSCROLL FONT '10.Lucida Console'

@ 8,102 DCPUSHBUTTON CAPTION 'Properties' SIZE 9,1.2 ACTION {||CJ_DisplayProperties(oEvent)}

DCGETOPTIONS SAYWIDTH 60 SAYRIGHTBOTTOM TABSTOP

DCREAD GUI FIT ADDBUTTONS TITLE IIF(lNew,'Adding','Editing') + ' event' ;
   MODAL SETAPPWINDOW TO lStatus OPTIONS GetOptions


IF lStatus
  oEvent:subject := Trim(cSubject)
  oEvent:body := cBody
  oEvent:location := Trim(cLocation)
  oEvent:privateFlag := lPrivate
  oEvent:meetingFlag := lMeeting
  oEvent:busyStatus := nBusyStatus
  oEvent:label := nLabel
  oEvent:reminder := lReminder
  oEvent:scheduleID := nScheduleID
  oEvent:allDayEvent := lAllDayEvent
  oEvent:reminderMinutesBeforeStart := nReminderMinutes
  oEvent:treatDateAsString(.t.)
  CJ_DateTime(@cDateTime,dStart,cStart)
  oEvent:startTime := cDateTime
  CJ_DateTime(@cDateTime,dEnd,cEnd)
  oEvent:endTime := cDateTime
  if lNew
      oCalendar:dataProvider:AddEvent(oEvent)
    else
      oCalendar:dataProvider:ChangeEvent(oEvent)
  endif
 /*   the DOxxxevents will take care of this.
	  IF lNew
	    oCalendar:dataProvider:addEvent(oEvent)
	  ELSE
	    oCalendar:dataProvider:changeEvent(oEvent)
	  ENDIF
	  //  oCalendar:populate()
	  IF !lNew
	  // put something here to find event in database
	  ENDIF
	  oRecord:subject := cSubject
	  oRecord:body := cBody
	  oRecord:location := Trim(cLocation)
	  oRecord:startDate := dStart
	  oRecord:endDate := dEnd
	  oRecord:startTime := cStart
	  oRecord:endTime := cEnd
	  oRecord:isPrivate := lPrivate
	  oRecord:isMeeting := lMeeting
	  oRecord:isReminder := lReminder
	  oRecord:remindTime := nReminderMinutes
	  oRecord:busyStatus := nBusyStatus
	  oRecord:eventID := oEvent:id
	  oRecord:isAllDay := lAllDayEvent
	  oRecord:user_id := cScheduleID
	  calendar->(rlock())
	  calendar->starttime := cStart
	  // calendar->(dbrunlock())
	  //  CALENDAR->(DC_DbGather(oRecord,lNew))
  */
ENDIF


RETURN nil


* -----------
STATIC FUNCTION DoubleClick( oCalendar, oRecord )
**************************************************
LOCAL oActiveView, oHitInfo, cName, nNo, cDateTime, dDate, cTime, ;
      oEvent, oViewEvent, nIndex, oCalendarViewEvent

oActiveView := oCalendar:ActiveView

IF oActiveView = NIL
  RETURN .F.
ENDIF

oHitInfo := oActiveView:HitTest()
nNo := oHitInfo:hitCode

oHitInfo:treatDateAsString(.t.)
cDateTime := oHitInfo:getProperty('hitDateTime')

CJ_DateTime(cDateTime,@dDate,@cTime)

oViewEvent := oHitInfo:viewEvent

IF CJ_IsOption(nNo,xtpCalendarHitTestDayHeader) // The position is inside a header
  // not sure what to do here yet
  // maybe creation of a new event?
  wtf 'click in header'

ELSEIF CJ_IsOption(nNo,xtpCalendarHitTestEventTextArea) // The position is inside an existing event
  oEvent := oHitInfo:ViewEvent:event
  EditEvent(oCalendar,oEvent,dDate,cTime,oRecord)

ELSEIF CJ_IsOption(nNo,xtpCalendarHitTestGroupArea)  // The position is inside a group area.
  // create a new event
  EditEvent(oCalendar,NIL,dDate,cTime)
ENDIF

RETURN nil